package com.zcloud.zcGbsServicer.web;

import com.alibaba.cola.dto.MultiResponse;
import com.alibaba.cola.dto.PageResponse;
import com.alibaba.cola.dto.Response;
import com.alibaba.cola.dto.SingleResponse;
import com.jjb.saas.framework.auth.model.SSOUser;
import com.jjb.saas.framework.auth.utils.AuthContext;
import com.zcloud.zcGbsServicer.api.PumpRoomServiceI;
import com.zcloud.zcGbsServicer.dto.PumpRoomAddCmd;
import com.zcloud.zcGbsServicer.dto.PumpRoomPageQry;
import com.zcloud.zcGbsServicer.dto.PumpRoomScreenQry;
import com.zcloud.zcGbsServicer.dto.PumpRoomUpdateCmd;
import com.zcloud.zcGbsServicer.dto.clientobject.PumpRoomCO;
import com.zcloud.zcGbsServicer.dto.clientobject.PumpRoomScreenCO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;

/**
 * web-adapter
 * @Author makejava
 * @Date 2026-01-21 17:22:16
 */
@Api(tags = "消防泵房")
@RequestMapping("/${application.gateway}/pumpRoom")
@RestController
@AllArgsConstructor
public class PumpRoomController {
    private final PumpRoomServiceI pumpRoomService;

    @ApiOperation("新增")
    @PostMapping("/save")
    public SingleResponse<PumpRoomCO> add(@Validated @RequestBody PumpRoomAddCmd cmd) {
        SSOUser ssoUser = AuthContext.getCurrentUser();
        return pumpRoomService.add(cmd);
    }

    @ApiOperation("分页")
    @PostMapping("/list")
    @PreAuthorize("@pms.hasAnyPermission('xfbf')")
    public PageResponse<PumpRoomCO> page(@RequestBody PumpRoomPageQry qry) {
        return pumpRoomService.listPage(qry);
    }

    @ApiOperation("所有数据")
    @GetMapping("/listAll")
    public MultiResponse<PumpRoomCO> listAll() {
        return MultiResponse.of(new ArrayList<PumpRoomCO>());
    }

    @ApiOperation("详情")
    @GetMapping("/{id}")
    public SingleResponse<PumpRoomCO> getInfoById(@PathVariable("id") Long id) {
        return SingleResponse.of(pumpRoomService.getInfoById(id));
    }

    @ApiOperation("删除")
    @DeleteMapping("/{id}")
    public Response remove(@PathVariable("id") Long id) {
        pumpRoomService.remove(id);
        return SingleResponse.buildSuccess();
    }

    @ApiOperation("批量删除")
    @DeleteMapping("/ids")
    public Response removeBatch(@RequestParam Long[] ids) {
        pumpRoomService.removeBatch(ids);
        return SingleResponse.buildSuccess();
    }

    @ApiOperation("修改")
    @PutMapping("/edit")
    public SingleResponse edit(@Validated @RequestBody PumpRoomUpdateCmd pumpRoomUpdateCmd) {
        pumpRoomService.edit(pumpRoomUpdateCmd);
        return SingleResponse.buildSuccess();
    }

    @ApiOperation("可视化大屏-消防泵房查询")
    @PostMapping("/screenList")
    public PageResponse<PumpRoomScreenCO> screenList(@RequestBody PumpRoomScreenQry qry) {
        return pumpRoomService.listScreen(qry);
    }
}
